<?php
//check access
if (!function_exists('is_admin')) {
	header('Status: 403 Forbidden');
	header('HTTP/1.1 403 Forbidden');
	exit();
}
//install code
function hamyar_ticket_install() {
	global $wpdb;
	global $hamyar_jal_db_version;
	$hamyar_jal_db_version = "1.0";
	$hamyar_table_name = $wpdb -> prefix . "hamyar_ticket";
	$hamyar_table_name2 = $wpdb -> prefix . "hamyar_ticket_r";
	$sql_hamyar = "CREATE TABLE IF NOT EXISTS $hamyar_table_name (`id` int(11) NOT NULL AUTO_INCREMENT,`describe` text CHARACTER SET utf8 COLLATE utf8_persian_ci NOT NULL,`close` tinyint(1) NOT NULL,`name` text CHARACTER SET utf8 COLLATE utf8_persian_ci NOT NULL,`email` text NOT NULL,`important` varchar(10) CHARACTER SET utf8 COLLATE utf8_persian_ci NOT NULL,`subj` text CHARACTER SET utf8 COLLATE utf8_persian_ci NOT NULL,`date` text CHARACTER SET utf8 COLLATE utf8_persian_ci NOT NULL,`msgcode` varchar(20) NOT NULL,`password` text NOT NULL,`ip` text NOT NULL,PRIMARY KEY (`id`,`close`)) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=38 ;";
	$sql_hamyar_2 = "CREATE TABLE IF NOT EXISTS $hamyar_table_name2 (`id` int(11) NOT NULL AUTO_INCREMENT,`describe` text CHARACTER SET utf8 COLLATE utf8_persian_ci NOT NULL,`name` text CHARACTER SET utf8 COLLATE utf8_persian_ci NOT NULL,`email` text COLLATE utf8_bin NOT NULL,`date` text CHARACTER SET utf8 COLLATE utf8_persian_ci NOT NULL,`msgcode` text COLLATE utf8_bin NOT NULL,`ip` text COLLATE utf8_bin NOT NULL,PRIMARY KEY (`id`),KEY `id` (`id`)) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;";
	require_once (ABSPATH . 'wp-admin/includes/upgrade.php');
	dbDelta($sql_hamyar);
	dbDelta($sql_hamyar_2);
	dbDelta("ALTER TABLE  $hamyar_table_name  CHANGE  `password`  `password` TEXT CHARACTER SET utf8 COLLATE utf8_persian_ci NOT NULL");
	add_option('hamyar_page');
	add_option('hamyar_date');
	update_option('hamyar_date', 'no');
	update_option('hamyar_jquery', 'yes');
}

#clean inputs for xss and sqli
function hamyar_clean($string) {
	global $wpdb;
	$string = trim($string);
	$string = htmlspecialchars($string);
	$string = strip_tags($string);
	$string = $wpdb -> prepare($string);
	return $string;
}

//get id for ticket
function hamyar_id($qtd) {
	$Caracteres = 'ABCDEFGHIJKLMOPQRSTUVXWYZ0123456789abcdefghijklmnopqrstuvwxyzhamyar';
	$QuantidadeCaracteres = strlen($Caracteres);
	$QuantidadeCaracteres--;
	$Hash = NULL;
	for ($x = 10; $x <= $qtd; $x++ * $x) { $Posicao = rand(0, $QuantidadeCaracteres);
		$Hash .= substr($Caracteres, $Posicao, 1);
	}
	global $wpdb;
	$ok = true;
	$hamyar_table_name = hamyar_ticket_get_table_name();
	$id = $wpdb -> get_results("SELECT msgcode FROM $hamyar_table_name WHERE msgcode='$Hash'", ARRAY_A);
	$id = $id[0];
	if (!isset($id['msgcode']))
		return $Hash;
	else
		hamyar_id($qtd);
}

//nl2br by hamyar ;)
function hamyar_nl2br2($string) {
	$string = str_replace(array('\r\n', '\r', '\n'), "<br/>", $string);
	return stripslashes($string);
}

//get date
function hamyar_date($x) {
	if ($x == 'yes') {
		require_once dirname(__FILE__) . '/jdatetime.class.php';
		$hamyar_date = new jDateTime(true, true, 'Asia/Tehran');
		return hamyar_clean($hamyar_date -> date("l j F Y H:i"));
	} else {
		return date('l jS \of F Y h:i:s A');
	}
}

//check id
function hamyar_check_id($id2) {
	global $wpdb;
	$ok = false;
	$hamyar_table_name = hamyar_ticket_get_table_name();
	$id = $wpdb -> get_results("SELECT msgcode FROM $hamyar_table_name WHERE msgcode='$id2'", ARRAY_A);
	$id = $id[0];
	if (isset($id['msgcode']))
		return true;
	return false;

}

//check pass
function hamyar_pass($pass) {
	global $wpdb;
	$ok = false;
	$hamyar_table_name = hamyar_ticket_get_table_name();
	$id = $_GET['hamyar_id'];
	$row = $wpdb -> get_results("SELECT password FROM $hamyar_table_name WHERE msgcode='$id'", ARRAY_A);
	if ($row[0]['password'] == $pass)
		return true;
	return false;
}

//check ticket
function hamyar_check_ticket() {
	if (isset($_GET['hamyar_id']) && isset($_GET['hamyar_pass'])) {
		if (!empty($_GET['hamyar_id']) && !empty($_GET['hamyar_pass'])) {
			if (hamyar_check_id($_GET['hamyar_id'])) {
				if (hamyar_pass($_GET['hamyar_pass'])) {
					return true;
				} else {
					return false;
				}
			} else {
				return false;
			}
		} else {
			return false;
		}
	} else {
		return false;
	}
}

//get security code
function hamyar_get_code() {
	@session_start();
	$string = '';
	for ($i = 0; $i < 4; $i++) {
		$string .= chr(rand(48, 57));
	}
	$_SESSION['hamyar_rand_code'] = '';
	$_SESSION['hamyar_rand_code'] = $string;
	return $_SESSION['hamyar_rand_code'];
}

//get ticket for user
function hamyar_get_ticket($id) {
	global $wpdb;
	$ok = false;
	$hamyar_table_name = hamyar_ticket_get_table_name();
	$row = $wpdb -> get_results("SELECT * FROM $hamyar_table_name WHERE msgcode='$id'", ARRAY_A);
	$row = $row[0];
	$return = '<div class="hamyar_margin"></div><input type="submit" class="btn" value="' . __('Subject', 'hts') . ': ' . $row['subj'] . '"/>';
	switch($row['close']) {
		case 0 :
			$close = __('Answered by admin(close ticket)', 'hts');
			break;
		case 1 :
			$close = __('The ticket is closed', 'hts');
			break;
		case 2 :
			$close = __('Answered by user(close ticket)', 'hts');
			break;
	}
	$return .= '<input type="submit" class="btn btn-primary" id="hamyar_close" value="' . $close . '"/>';
	$return .= '<input type="submit" id="hamyar_copy" class="btn" value="' . __('ID: ', 'hts') . $row['msgcode'] . '"/>';
	$return .= '<input type="hidden" id="hamyar_copy2"  value="' . $row['msgcode'] . '"/>';
	$return .= '<div class="hamyar_box2"><h1>' . $row['name'] . '(' . $row['email'] . ')' . '<div class="hamyar_date">' . $row['date'] . '</div>' . '</h1><div class="hamyar_margin"></div>' . hamyar_nl2br2($row['describe']) . '</div>';
	return $return;
}

//get ticket answers
function hamyar_get_tickets($id) {
	global $wpdb;
	$ok = false;
	$return = '';
	$hamyar_table_name = $wpdb -> base_prefix . "hamyar_ticket_r";
	$id = $wpdb -> get_results("SELECT * FROM $hamyar_table_name WHERE msgcode='$id' ORDER BY id ASC", ARRAY_A);
	foreach ($id as $row) {
		$return .= '<div class="hamyar_box2"><h1>' . $row['name'] . '(' . $row['email'] . ')' . '<div class="hamyar_date">' . $row['date'] . '</div>' . '</h1><div class="hamyar_margin"></div>' . hamyar_nl2br2($row['describe']) . '</div>';
	}
	return $return;
}

//regsiter admin panel
function hamyar_ticket_settings_init() {
	register_setting('hamyar_ticket_settings', 'hamyar_ticket_settings');
}

//get tickets for admin
function hamyar_get_admin_ticket($hamyar_result) {
	global $wpdb;
	if ($hamyar_result) {
		foreach ($hamyar_result as $hamyar_subject) {
			$hamyar = get_option('hamyar_page');
			$hamyar .= '?hamyar_do=read&hamyar_pass=' . $hamyar_subject['password'] . '&hamyar_id=' . $hamyar_subject['msgcode'];
			echo "<li><a target='_blank' href='$hamyar'>";
			echo $hamyar_subject['subj'];
			echo '</a>|';
			_e(' BY:', 'hts');
			echo $hamyar_subject['name'] . '|';
			_e('IN:', 'hts');
			echo $hamyar_subject['date'] . '|';
			_e('STATUS:', 'hts');
			switch($hamyar_subject['close']) {
				case 0 :
					$close = __('Answered by admin', 'hts');
					break;
				case 1 :
					$close = __('The ticket is closed', 'hts');
					break;
				case 2 :
					$close = __('Answered by user', 'hts');
					break;
			}
			echo $close . '|';
			echo '<a style="color:red" onClick="hamyar_delete(' . "'" . $hamyar_subject['msgcode'] . "'" . ')">' . __('Delete', 'hts') . '</a>';
			echo "</li>";
		}
	}

}

//create queries for get tickets
function hamyar_admin_ticket() {
	global $wpdb;
	$hamyar_table_name = hamyar_ticket_get_table_name();
	$hamyar_result = array();
	$hamyar_result[0] = $wpdb -> get_results("Select * FROM $hamyar_table_name WHERE close='2' AND important='high' ORDER BY id ASC", ARRAY_A);
	$hamyar_result[1] = $wpdb -> get_results("Select * FROM $hamyar_table_name WHERE close='2' AND important='normal' ORDER BY id ASC", ARRAY_A);
	$hamyar_result[2] = $wpdb -> get_results("Select * FROM $hamyar_table_name WHERE close='2' AND important='low' ORDER BY id ASC", ARRAY_A);
	$hamyar_result[3] = $wpdb -> get_results("Select * FROM $hamyar_table_name WHERE close='0' AND important='high' ORDER BY id ASC", ARRAY_A);
	$hamyar_result[4] = $wpdb -> get_results("Select * FROM $hamyar_table_name WHERE close='0' AND important='normal' ORDER BY id ASC", ARRAY_A);
	$hamyar_result[5] = $wpdb -> get_results("Select * FROM $hamyar_table_name WHERE close='0' AND important='low' ORDER BY id ASC", ARRAY_A);
	$hamyar_result[6] = $wpdb -> get_results("Select * FROM $hamyar_table_name WHERE close='1' AND important='high' ORDER BY id ASC", ARRAY_A);
	$hamyar_result[7] = $wpdb -> get_results("Select * FROM $hamyar_table_name WHERE close='1' AND important='normal' ORDER BY id ASC", ARRAY_A);
	$hamyar_result[8] = $wpdb -> get_results("Select * FROM $hamyar_table_name WHERE close='1' AND important='low' ORDER BY id ASC", ARRAY_A);
	for ($i = 0; $i < 9; $i++) {
		echo '<ul>';
		hamyar_get_admin_ticket($hamyar_result[$i]);
		echo '</ul>';
	}
}

//hamyar news
function hamyar_news() {
	$xml = simplexml_load_file('http://hamyar.org/feed');
	echo '<ul>';
	for ($i = 0; $i < 5; $i++) { $title = $xml -> channel -> item[$i] -> title;
		$link = $xml -> channel -> item[$i] -> link;
		echo '<a href="' . $link . '""><li>' . $title . '</li></a>';
	}
	echo '</ul>';
}

function hamyar_script() {
	$hamyar_jquery = get_option("hamyar_jquery");
	if ($hamyar_jquery == 'yes')
		wp_enqueue_script('jquery');
}

//get table name
function hamyar_ticket_get_table_name() {
	global $wpdb;
	return $wpdb -> base_prefix . "hamyar_ticket";
}
?>